<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\SetoresService;

class SetoresController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $SetoresService;
   
    public function __construct($crudService, $environment, SetoresService $SetoresService) {
        parent::__construct($crudService, $environment);
        $this->SetoresService = $SetoresService;
    }

    public function getSectorsController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        
        $var = $this->SetoresService->getSectorsService($params);
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function sectorsListController(DTO\Request $request, DTO\Response $response) {
        $var = $this->SetoresService->sectorsListService();
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function createsectorController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();

        $nmsetor = $params['sectorInfos']['NMSETOR'];
        $nrfuncresponsavel = $params['sectorInfos']['NRFUNCRESPONSAVEL'];
        
        $var = $this->SetoresService->createSectorService($nmsetor, $nrfuncresponsavel);
        $dtsVal = new DataSet('info',array("message" => $var));
        $response->addDataSet($dtsVal);
    }
    
    public function getSectorInfosController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        
        $nrsetor = $params['params']['NRSETOR'];
        
        $var = $this->SetoresService->getSectorInfosService($nrsetor);
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function updateSectorController(DTO\Request $request, DTO\Response $response) {
        
        $params = $request->getParameters();

        $nrsetor = $params['params']['NRSETOR'];
        $nmsetor = $params['params']['NMSETOR'];
        $nrfuncresponsavel = $params['params']['NRFUNCRESPONSAVEL'];
        
        $var = $this->SetoresService->updateSectorService($nrsetor, $nmsetor, $nrfuncresponsavel);
        $dtsVal = new DataSet('info',array("message" => $var));
        $response->addDataSet($dtsVal);
    }
    
    public function deleteSectorsController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();

        $var = $this->SetoresService->deleteSectorsService($params);
        $dtsVal = new DataSet('info', array("resultado" => $var));
        $response->addDataSet($dtsVal);
    }
    
    public function getLinkedLocalsController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        
        $var = $this->SetoresService->getLinkedLocalsService($params["id"]);
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }

}
?>