/* eslint-disable no-console */
import {
  Http, IDictionary, Metadata,
} from '@zeedhi/core';
import {
  Modal, ModalService, Text,
} from '@zeedhi/common';

export class ModalPAcessoController {
  private modalSetor!: Modal;

  private modalFuncao!: Modal;

  private modalUsuario!: Modal;

  /* -------- Criar Modais -------- */

  public async createModalSetor() {
    this.modalSetor = await ModalService.createFromJson('/modal/modalNovoSetor', true);
  }

  public async createModalFuncao() {
    this.modalFuncao = await ModalService.createFromJson('/modal/modalNovaFuncao', true);
  }

  public async createModalUsuario() {
    this.modalUsuario = await ModalService.createFromJson('/modal/modalNovoUsuario', true);
  }

  /* -------- Destruir Modais -------- */

  public destroyModalSetor() {
    this.modalSetor.destroy();
  }

  public destroymodalFuncao() {
    this.modalFuncao.destroy();
  }

  public destroyModalUsuario() {
    this.modalUsuario.destroy();
  }

  /* -------- Abrir Modais -------- */

  public openModalSetor() {
    this.modalSetor.show();
  }

  public openModalFuncao() {
    this.modalFuncao.show();
  }

  public async openModalUsuario(nr: any) {
    this.modalUsuario = await ModalService.createFromJson('/modal/modalNovoUsuario', true);
    await this.modalUsuario.show();
    Metadata.getInstance<Text>('titleTextNewEmployee').name = `titleTextNewEmployee_${nr}`;
  }

  /* -------- Fechar Modais -------- */

  public closeModalSetor() {
    this.modalSetor.hide();
  }

  public closeModalFuncao() {
    this.modalFuncao.hide();
  }

  public async closeModalUsuario() {
    this.textObject = 'Novo Usuário';
    this.nrfuncionario = null;
    this.userName = null;
    this.positionSelect = null;
    this.relacfuncperfacess = null;
    this.userCPF = null;
    this.userRG = null;
    this.userEmail = null;
    this.userTel = null;
    this.userPassword = null;
    this.sectorSelect = null;
    this.nrrelacfuncsetor = null;
    this.SelectOperador = null;
    await this.modalUsuario.hide();
    this.modalUsuario.destroy();
  }

  /* ---------- Inicializações ---------- */

  public selectsData: IDictionary = {
    positionSelect: [],
    sectorSelect: [],
    userSelect: [],
  };

  // Usuário
  public initializeUserData() {
    this.setUserSelect();
  }

  public setData(infoName: string, infoValue: number) {
    return {
      name: infoName,
      value: infoValue,
    };
  }

  public setSelectsData({ component }: any) {
    Http.get('/positionsList').then((response: IDictionary) => {
      component.datasource.updateData(response.data.dataset.info);
    }).then(() => {
      component.setValue(this.positionSelect);
    });
  }

  // Seta "Setores" no Select "Setor"
  public setSectorSelect({ component }: any) {
    Http.get('/sectorsList').then((response: IDictionary) => {
      component.datasource.updateData(response.data.dataset.info);
    }).then(() => {
      component.setValue(this.sectorSelect);
    });
  }

  // Seta "Usuários" no select "Responsável"
  public setUserSelect() {
    Http.get('/usersList').then((response: IDictionary) => {
      response.data.dataset.info.forEach((database: IDictionary) => {
        this.selectsData.userSelect.push(this.setData(database.NMFUNCIONARIO, database.NRFUNCIONARIO));
      });
    });
  }

  public setOperadorSelect({ component }: any) {
    Http.get('/getOperador').then((response: IDictionary) => {
      component.datasource.updateData(response.data.dataset.operadores);
    }).then(() => {
      // component.setValue('004156468486');
      component.setValue(this.SelectOperador);
    });
  }

  private valoresUpdate: any;

  public setVar(valores: any) {
    this.valoresUpdate = valores;
  }

  public textObject: any = 'Novo Usuário';

  public nrfuncionario: any = null;

  public userName: any = null;

  public positionSelect: any = null;

  public relacfuncperfacess: any = null;

  public userCPF: any = null;

  public userRG: any = null;

  public userEmail: any = null;

  public userTel: any = null;

  public userPassword: any = null;

  public sectorSelect: any = null;

  public nrrelacfuncsetor: any = null;

  public SelectOperador: any = null;

  public isDisabledElement: boolean = false;

  public setUserToUpdate() {
    const params = {
      NRFUNCIONARIO: Number(Metadata.getInstance<Text>('titleTextNewEmployee').name.split('_')[1]),
    };

    Http.post('/getUserInfos', { params }).then((response: IDictionary) => {
      response.data.dataset.info.forEach((database: IDictionary) => {
        this.nrfuncionario = database.NRFUNCIONARIO;
        this.userName = database.NMFUNCIONARIO;
        this.positionSelect = database.NRPERFILACESSO;
        this.relacfuncperfacess = database.RELACFUNCPERFACESS;
        this.userCPF = database.NRCPFFUNCIONARIO;
        this.userRG = database.NRRGFUNCIONARIO;
        this.userEmail = database.DSEMAILFUNCIONARIO;
        this.userTel = (database.NRTELFUNCIONARIO).toString();
        this.userPassword = database.DSSENHAFUNC;
        this.sectorSelect = database.NRSETOR;
        this.nrrelacfuncsetor = database.NRRELACFUNCSETOR;
        this.SelectOperador = database.CDOPERADOR;
      });
    });
  }
}
